bm::xor_sim_params Struct Reference

Parameters for XOR similarity search. More...

`#include <bmxor.h>`

## Public Member Functions

| xor_sim_params ()

## Data Fields

unsigned | min_lookup_depth
unsigned | max_lookup_depth
unsigned | stop_gain
float | target_gain_ratio
unsigned | min_gaps

## Detailed Description

Parameters for XOR similarity search.

Tuneup params allows to reduce the search space to better balance compression rate vs speed.

min_lookup_depth - default: 0, minimal search depth to still try to improve max_lookup_depth - default: (2billion) maximum scan search Set a smaller number to improve search time

Example: min_lookup_depth = 64; max_lookup_depth = 1024;

stop_gain - default: 65533 - cutoff to stop search when serch found gain better than "stop_gain" absolute value Example: stop_gain = 10000;

target_gain_ratio - default: 0.89 - cut off ratio between original block cost metric and XOR basedd metric to stop searching. (90% better than the original block is "good enough") Example: target_gain_ratio = 0.50; // 50% improvement is good enough

min_gaps - default: 3 - minimal size of GAP block to be considered for XOR search candidate

Examples
  rscsample05.cpp.

Definition at line 58 of file bmxor.h.

## Constructor & Destructor Documentation

## xor_sim_params()

bm::xor_sim_params::xor_sim_params | ( |  | ) |

inline

Definition at line 66 of file bmxor.h.

References bm::gap_max_bits, max_lookup_depth, min_gaps, min_lookup_depth, stop_gain, and target_gain_ratio.

## Field Documentation

## max_lookup_depth

unsigned bm::xor_sim_params::max_lookup_depth

Definition at line 61 of file bmxor.h.

Referenced by bm::xor_scanner< BV >::search_best_xor_mask(), and xor_sim_params().

## min_gaps

unsigned bm::xor_sim_params::min_gaps

Definition at line 64 of file bmxor.h.

Referenced by bm::xor_scanner< BV >::compute_sim_model(), bm::xor_scanner< BV >::deoptimize_gap_blocks(), and xor_sim_params().

## min_lookup_depth

unsigned bm::xor_sim_params::min_lookup_depth

Definition at line 60 of file bmxor.h.

Referenced by bm::xor_scanner< BV >::search_best_xor_mask(), and xor_sim_params().

## stop_gain

unsigned bm::xor_sim_params::stop_gain

Definition at line 62 of file bmxor.h.

Referenced by bm::xor_scanner< BV >::search_best_xor_mask(), and xor_sim_params().

## target_gain_ratio

float bm::xor_sim_params::target_gain_ratio

Definition at line 63 of file bmxor.h.

Referenced by bm::xor_scanner< BV >::search_best_xor_mask(), and xor_sim_params().

The documentation for this struct was generated from the following file:

- bmxor.h